package cat.hack3.codingtests.marsrover.commands;


import cat.hack3.codingtests.marsrover.api.RotableRiderRover;
import cat.hack3.codingtests.marsrover.api.commands.CommandFactory;
import cat.hack3.codingtests.marsrover.api.commands.RoverCommand;

public class RoverCommandFactory implements CommandFactory {
    private final RotableRiderRover rover;

    public RoverCommandFactory(RotableRiderRover rover) {
        this.rover = rover;
    }

    @Override
    public RoverCommand createCommand(RoverCommand.Type type) {
        return switch (type) {
            case MOVE_FORWARD -> new MoveForwardCommand(rover);
            case MOVE_BACKWARDS -> new MoveBackwardsCommand(rover);
            case TURN_LEFT -> new TurnLeftCommand(rover);
            case TURN_RIGHT -> new TurnRightCommand(rover);
        };
    }
}
